package com.example.helloworld;

import android.app.Activity;
import android.content.Context;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;
import android.widget.Toast;

public class ActivityCoordinates extends Activity {
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_coordinates);
		
		//get reference to location manager
		LocationManager lm = (LocationManager) this.getSystemService(Context.LOCATION_SERVICE);
		
		//listener definition
		// for localization updates
		LocationListener ll = new LocationListener(){
			
			@Override
			public void onLocationChanged(Location loc) {
				String s = getString(R.string.yourCoordinates) + getString(R.string.latitude) + loc.getLatitude() + getString(R.string.longitude) + loc.getLongitude();
				Toast.makeText(getApplicationContext(), s, Toast.LENGTH_LONG).show();
				System.out.println(s);
			}

			@Override
			public void onStatusChanged(String provider, int status,
					Bundle extras) {
				// TODO Auto-generated method stub
				
			}

			@Override
			public void onProviderEnabled(String provider) {
				// TODO Auto-generated method stub
				
			}

			@Override
			public void onProviderDisabled(String provider) {/*
				Toast.makeText(getApplicationContext(), getString(R.string.providerDisabled), Toast.LENGTH_LONG).show();

				System.out.println(getString(R.string.providerDisabled));*/
			}
			
		};

		//register listener with locationManager for receiving updates
		lm.requestLocationUpdates(LocationManager.NETWORK_PROVIDER, 0, 0, ll);
		
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.main, menu);
		return true;
	}

	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		// Handle action bar item clicks here. The action bar will
		// automatically handle clicks on the Home/Up button, so long
		// as you specify a parent activity in AndroidManifest.xml.
		int id = item.getItemId();
		if (id == R.id.action_settings) {
			return true;
		}
		return super.onOptionsItemSelected(item);
	}
 

	
}
