package com.prorace.jpa;


import android.os.Parcel;
import android.os.Parcelable;

public class Race implements Parcelable{
	private String name;
	private String discipline;
	private int laps;
	private java.util.Date dateTime;
	private int limitTime;
	private int maxCompetitors;
	private Map map;

	public Race (){
		map = new Map();
	}
	
	public Race (String name, String discipline, int laps, java.util.Date dateTime, int limitTime, int maxCompetitors){
		this.name = name;
		this.discipline = discipline;
		this.laps = laps;
		this.dateTime = dateTime;
		this.limitTime = limitTime;
		this.maxCompetitors = maxCompetitors;
		map = new Map();
	}
	
	public Race (String name, String discipline, int laps, java.util.Date dateTime, int limitTime, int maxCompetitors, Map map){
		this.name = name;
		this.discipline = discipline;
		this.laps = laps;
		this.dateTime = dateTime;
		this.limitTime = limitTime;
		this.maxCompetitors = maxCompetitors;
		this.map = map;
	}
	
	//getters
	
	public String getName (){
		return this.name;
	}
	
	public String getDiscipline (){
		return this.discipline;
	}
	
	public int getLaps (){
		return this.laps;
	}
	
	public java.util.Date getDateTime (){
		return this.dateTime;
	}
	
	public int getLimitTime (){
		return this.limitTime;
	}
	
	public int getMaxCompetitors (){
		return this.maxCompetitors;
	}
	
	public Map getMap (){
		return this.map;
	}

	//setters
	
	public void setName (String name){
		this.name = name;
	}
	
	public void setDiscipline (String discipline){
		this.discipline = discipline;
	}
	
	public void setLaps (int laps){
		this.laps = laps;
	}
	
	public void setDateTime (java.util.Date dateTime){
		this.dateTime = dateTime;
	}
	
	public void setLimitTime (int limitTime){
		this.limitTime = limitTime;
	}
	
	public void setMaxCompetitors (int maxCompetitors){
		this.maxCompetitors = maxCompetitors;
	}
	
	public void setMap (Map map){
		this.map = map;
	}

	@Override
	public int describeContents() {
		// TODO Auto-generated method stub
		return 0;
	}
	
	public Race(Parcel in ) {
        readFromParcel( in );
    }

    public static final Parcelable.Creator CREATOR = new Parcelable.Creator() {
        public Race createFromParcel(Parcel in ) {
            return new Race( in );
        }

        public Race[] newArray(int size) {
            return new Race[size];
        }
    };
	
	public void readFromParcel(Parcel in){
		name = in.readString();
		discipline = in.readString();
		laps = in.readInt();
		dateTime = (java.util.Date) in.readSerializable();
		maxCompetitors = in.readInt();
		limitTime = in.readInt();
		map = in.readParcelable(Map.class.getClassLoader());
	}

	@Override
	public void writeToParcel(Parcel dest, int flags) {
		dest.writeString(name);
		dest.writeString(discipline);
		dest.writeInt(laps);
		dest.writeSerializable(dateTime);
		dest.writeInt(maxCompetitors);
		dest.writeInt(limitTime);
		dest.writeParcelable(map, flags);
		
	}
}
