package com.prorace.model;

public enum ErrorCode {

	NULL (0, "OK"),
	DATE_BEFORE (1, "FIX A DATE IN THE FUTURE"),
	LIMIT_TIME_NEGATIVE (2, "LIMIT TIME MUST BE A POSITIVE VALUE"),
	MAX_COMPETITORS_NEGATIVE (3, "MAXIM NUMBER OF COMPETITORS MUST BE A POSITIVE VALUE"),
	DATE_FORMAT_ERROR (4, "AN ERROR OCCURRED WITH DATE AND TIME. PLEASE, INTRODUCE DATE AND TIME USING THE DIALOG"),
	ERROR_PASSING_PARAMETERS_CREATE_RACE (5, "INTERNAL ERROR PASSING PARAMETERS. PLEASE, CREATE RACE AGAIN");
	
	private int code;
	private String error;
	
	android.util.SparseArray<ErrorCode> codeToErrorMapping;
	
	private ErrorCode (int code, String error){
		this.code = code;
		this.error = error;
	}

	public ErrorCode getError(int error){
		if (codeToErrorMapping == null)
			initMapping();
		return codeToErrorMapping.get(error);
	}

	public int getCode (){
		return this.code;
	}

	public String getError (){
		return this.error;
	}

	public void initMapping(){
		codeToErrorMapping = new android.util.SparseArray<ErrorCode>();
		for ( ErrorCode e : values())
			codeToErrorMapping.put(e.code, e);
	}

	@Override
	public String toString(){
		return "{Error "+getCode()+": "+getError()+"}";
	}
}
