package com.prorace.viewcontroller;

import com.google.android.gms.maps.CameraUpdateFactory;
import com.google.android.gms.maps.GoogleMap;
import com.google.android.gms.maps.MapFragment;
import com.google.android.gms.maps.OnMapReadyCallback;
import com.google.android.gms.maps.model.LatLng;
import com.google.android.gms.maps.model.PolylineOptions;
import com.prorace.jpa.*;

import android.app.Activity;
import android.graphics.Color;
import android.os.Bundle;

public class ActivityDisplayRace extends Activity implements OnMapReadyCallback{
	
	Race race;

    protected void onCreate(Bundle savedInstanceState) {
    	
    	super.onCreate(savedInstanceState);
    	setContentView(R.layout.activity_display_race);

    	initialize();

    }
    
    public void initialize(){
    	
    	race = new Race();
    	race = getIntent().getExtras().getParcelable("race");
    	
    	MapFragment mapFragment = (MapFragment) getFragmentManager().findFragmentById(R.id.waitingMap);
    	mapFragment.getMapAsync(this);
    	
    }

	@Override
	public void onMapReady(GoogleMap map) {
		
		LatLng pos;
		PolylineOptions pl = new PolylineOptions().geodesic(true);
        
		map.setMyLocationEnabled(true);
        map.getUiSettings().setZoomControlsEnabled(true);
        map.getUiSettings().setCompassEnabled(true);
        map.getUiSettings().setAllGesturesEnabled(true);
        map.getUiSettings().setCompassEnabled(true);
        
        pos = toLatLng(race.getMap().getStart());
        map.moveCamera(CameraUpdateFactory.newLatLngZoom(pos, 17));
        
        pl.add (pos);
        
        for (int i=0; i<race.getMap().getTravel().size(); i++){
        	pos = toLatLng (((java.util.ArrayList <Point>) race.getMap().getTravel()).get(i));
        	pl.add (pos);
        }
        
        pos = toLatLng(race.getMap().getFinish());
        pl.add (pos);
        
        pl.color(Color.RED);
        
        map.addPolyline(pl);
		map.setMapType(GoogleMap.MAP_TYPE_SATELLITE);
	}
	
	public LatLng toLatLng (Point p){
		return new LatLng (p.getX(), p.getY());
	}
    

}
