package com.prorace.viewcontroller;


import android.annotation.SuppressLint;
import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.view.KeyEvent;
import android.view.Menu;
import android.view.MenuItem;
import android.view.MotionEvent;
import android.view.View;
import android.view.View.OnTouchListener;
import android.view.inputmethod.EditorInfo;
import android.view.inputmethod.InputMethodManager;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.TextView.OnEditorActionListener;
import android.widget.Toast;

public class MainActivity extends Activity implements OnTouchListener, OnEditorActionListener{

	private static boolean exit = false;
	Button create, results;
	EditText search;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.main_activity);
		setRequestedOrientation(1);
		
		initialize();

	}
	
	public void initialize(){
		create = (Button) findViewById(R.id.create);
		results = (Button) findViewById(R.id.results);
		
		search= (EditText) findViewById(R.id.search);
		search.setOnEditorActionListener(this);
		search.setOnTouchListener(this);
	}
	
	public void onClick_newRace(View v){
		exit = false;
		Intent i = new Intent();
		i.setClass(getApplicationContext(), ActivityCreate.class);
		startActivity(i);
	}
	
	public void onClick_watchResults(View v){
		exit = false;
		Intent i = new Intent();
		i.setClass(getApplicationContext(), ActivityResults.class);
		startActivity(i);
	}
	
	@Override
	public boolean onEditorAction (TextView t, int actionId, KeyEvent event){
		exit = false;
		if (actionId == EditorInfo.IME_ACTION_SEARCH){
			//TODO order model to ask server for this race
			Toast.makeText(getApplicationContext(), "Option disabled in prototype app", Toast.LENGTH_LONG).show();
			return true;
		}
		return false;
	}
	
	@SuppressLint("ClickableViewAccessibility")
	@Override
	public boolean onTouch(View v, MotionEvent event) {
		exit = false;

		if(event.getAction() == MotionEvent.ACTION_UP) {
			System.out.println(event.getRawX() + " >= " +search.getRight()+" - "+ search.getCompoundDrawables()[2].getBounds().width());
			if(event.getRawX() >= ((search.getRight()) - search.getCompoundDrawables()[2].getBounds().width())) {
				Toast.makeText(getApplicationContext(), "Option disabled in prototype app", Toast.LENGTH_LONG).show();
				return true;
            }
        }
        return false;
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.main, menu);
		return true;
	}

	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		// Handle action bar item clicks here. The action bar will
		// automatically handle clicks on the Home/Up button, so long
		// as you specify a parent activity in AndroidManifest.xml.
		exit = false;
		int id = item.getItemId();
		if (id == R.id.profile) {
			//TODO
			Toast.makeText(getApplicationContext(), "Option disabled in prototype app", Toast.LENGTH_LONG).show();
			return true;
		}
		return super.onOptionsItemSelected(item);
	}
	
	@Override
	public void onBackPressed(){
		if(exit)
			finish();
		else{
			InputMethodManager imm = (InputMethodManager)getSystemService(Context.INPUT_METHOD_SERVICE);
			imm.hideSoftInputFromWindow(search.getWindowToken(), 0);
			Toast.makeText(getApplicationContext(), R.string.mainExitApp, Toast.LENGTH_LONG).show();
			exit = true;
		}
	}
}
